#include<iostream.h>
#include<tobiMath.hh>

main()
{
  int i,j,n;
  double tmp;

  cout << "\n cbrt(2)**-3: " << pow(cbrt(2.0),-3) << endl;

  cout << "\n Matrix dimension:" << endl;
  cin >> n; cout << n << endl;

  double** S= new (double*)[n];
  double** S_bak= new (double*)[n];

  cout << "\n Symmetric Matrix:" << endl;
  for(i=0;i<n;i++){
    S[i]=new (double)[i+1];
    S_bak[i]=new (double)[i+1];
    for(j=0;j<=i;j++)
      {
	cin >> S[i][j];
	S_bak[i][j] = S[i][j];
	cout << S[i][j] << ",";
      }
    cout << endl;
  }
  cout << "\n Right hand side:" << endl;

  double* b= new (double)[n];
  double* b_bak= new (double)[n];
  double* c= new (double)[n];
  for(i=0;i<n;i++){
    cin >> b[i];
    b_bak[i]=b[i];
    cout << b[i] << ",";
  }
  cout << endl;

  if(lin_solve_cholesky(n,S,b)){
    cout << "\n Solution:\n";
    for(i=0;i<n;i++)
      {
	cout << b[i] << ",";
	tmp=0.0;
	for(j=0;j<=i;j++)
	  tmp += S_bak[i][j]*b[j];
	for(j=i+1;j<n;j++)
	  tmp += S_bak[j][i]*b[j];
	c[i]=tmp;
      }
    cout << "\n Zero-Check:\n" ;
    for(i=0;i<n;i++)
      {
	cout << c[i]-b_bak[i] << ",";
      }
    cout << endl;
  }
  else {
    cerr << "\n Singular system!"<<endl;
  }


  for(i=0;i<n;i++) delete [] S[i];
  delete [] S;
  for(i=0;i<n;i++) delete [] S_bak[i];
  delete [] S_bak;
  delete [] b;
  delete [] c;
  delete [] b_bak;
}
