!a.out input.dat

splot 'test.dat'


######################################################################
# Aequipotentiallinien:
set auto
set nosur
set contour
set cntrparam cubicspline
set view 0,0
splot 'pot.dat'
set output 'pot.eps'
set term post
repl
set term x11

set cntrparam levels incr 0.090,0.1,1.1
splot 'pot.kreis.dat'
set output 'pot.kreis.eps'
set term post
repl
set term x11


set sur
set cntrparam levels auto
splot 'potkomb.dat' using 1:2:($3-$6)
set output 'pot-abweichung-sing-int-1.7-zu-exakt.eps'
set term post
repl
set term x11
######################################################################
# Bahnkurven eintragen:
set nokey
set noztics
set xrange [-0.03:0.03]
set yrange [0.0:0.03]
splot 'pot.dat' with lines 0, 'pot.dat' using (-$1):2:3 with lines 0, 'bahnkurve25.dat' using 2:3:(0) with lines 1, 'bahnkurve50.dat' using 2:3:(0) with lines 1, 'bahnkurve100.dat' using 2:3:(0) with lines 1
######################################################################
set output 'pot-bahnkurven.eps'
set term post
repl
set term x11


set size ratio 2
set xrange [1e-2:3e-2]
set yrange [0:5e-2]

set cntrparam levels incr 0.9,0.02,0.99
set cntrparam levels incr 0.0,0.05,0.91

set  xrange [0.01:1.5e-2]
set yrange [0:1e-2]
repl

set cntrparam levels incr 0.0,0.01,0.91
set nokey
set  xrange [0:16e-2]
set yrange [0:10e-2]
repl

plot 'ez.dat'
